#include <stdio.h>
#include "reseau.h"

#define SOURCE 42
#define DESTINATION 26
#define FEMISSION  "flux2.dat"
#define FRECEPTION "flux1.dat"

int main(void)
/* Programme principal */
{
  int AS,AD;
  ttampon TamponReception;
  ttrame Trame;

  fprintf(stderr,"Initialisation du protocole 3\n");
  initialise_couche_physique(FEMISSION, FRECEPTION);
  initialise_couche_reseau(SOURCE, DESTINATION);

  while(1)
  {
    attendre(SIGRECU);
    prendre_de_la_couche_physique(&Trame);
    recuperer_donnees(Trame, &TamponReception, &AS, &AD);
    fprintf(stderr,"Trame recue : %s\n",TamponReception.info);
    envoyer_vers_couche_reseau(TamponReception, AS, AD);
    strcpy(TamponReception.info,"ACK");
    construire_trame(AD, AS, TamponReception, &Trame);
    fprintf(stderr,"Acquitement envoye\n");
    envoyer_vers_couche_physique(Trame);
  }
}
